"""
Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
"""
import os
import sys

from wsgidav.server import run_server
from wsgidav.wsgidav_app import WsgiDAVApp

"""
Central WSGI script. Used as the main entry point when the WebDAV service is deployed to the
WSGI container (e.g. to Apache with mod_wsgi).
"""


def get_site_folder():
    return os.path.dirname(os.path.realpath(__file__))


def get_config_filename():
    return '%s/wsgi.conf' % get_site_folder()

# Make sure that all the source files in the project directory are loaded.
path = get_site_folder()
if path not in sys.path:
    sys.path.append(path)


def application(environ, start_response):
    """
    Main WSGI entry point. Publishes wsgidav app class to the WSGI container.
    :param environ: WSGI environment dictionary (required by the WSGI interface).
    :param start_response: request handler (required by the WSGI interface).
    :return: response generator function
    """
    # noinspection PyProtectedMember
    config = run_server._readConfigFile(get_config_filename(), 3)

    app = WsgiDAVApp(config)
    return app(environ, start_response)
