"""
Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
"""
from pwd import getpwnam


class PwDomainController(object):
    def __repr__(self):
        return self.__class__.__name__

    def getDomainRealm(self, inputURL, environ):
        return "PwEntry Authentication Realm"

    def requireAuthentication(self, realmname, environ):
        return True

    def isRealmUser(self, realmname, username, environ):
        try:
            pw_entry = getpwnam(username)
            if (not self.is_root_allowed()) and self.is_root(pw_entry):
                return False
        except KeyError:
            return False
        return True

    def getRealmUserPassword(self, realmname, username, environ):
        # Empty string is used by default
        return ""

    def authDomainUser(self, realmname, username, password, environ):
        return self.isRealmUser(realmname, username, environ)

    def is_root_allowed(self):
        # [KN] We might want to have such a setting in the config file in future.
        return False

    def is_root(self, pw_entry):
        return pw_entry.pw_uid == 0
